diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/wifi/model/he/he-frame-exchange-manager.cc ns-3.38/src/wifi/model/he/he-frame-exchange-manager.cc
--- ns-3.37/src/wifi/model/he/he-frame-exchange-manager.cc	2022-11-01 17:37:24.743395800 -0700
+++ ns-3.38/src/wifi/model/he/he-frame-exchange-manager.cc	2023-03-16 20:54:23.856869200 -0700
@@ -1297,10 +1618,9 @@
             // Block acknowledgment context
             blockAck.SetAckType(false, index);
 
-            auto addressTidPair = staInfo.first;
-            auto agreementIt = m_agreements.find(addressTidPair);
-            NS_ASSERT(agreementIt != m_agreements.end());
-            agreementIt->second.FillBlockAckBitmap(&blockAck, index);
+            auto agreement = m_mac->GetBaAgreementEstablishedAsRecipient(receiver, tid);
+            NS_ASSERT(agreement);
+            agreement->get().FillBlockAckBitmap(&blockAck, index);
             NS_LOG_DEBUG("Multi-STA Block Ack: Sending Block Ack with seq="
                          << blockAck.GetStartingSequence(index) << " to=" << receiver
                          << " tid=" << +tid);
@@ -1321,17 +1641,30 @@
     Ptr<WifiPsdu> psdu =
         GetWifiPsdu(Create<WifiMpdu>(packet, hdr), acknowledgment->multiStaBaTxVector);
 
-    // The Duration/ID field in a BlockAck frame transmitted in response to a frame
-    // carried in HE TB PPDU is set according to the multiple protection settings
-    // (Sec. 9.2.5.7 of 802.11ax D3.0)
     Time txDuration = m_phy->CalculateTxDuration(GetBlockAckSize(acknowledgment->baType),
                                                  acknowledgment->multiStaBaTxVector,
                                                  m_phy->GetPhyBand());
-    WifiTxParameters params;
-    // if the TXOP limit is null, GetPsduDurationId returns the acknowledgment time,
-    // hence we set an method with acknowledgment time equal to zero.
-    params.m_acknowledgment = std::unique_ptr<WifiAcknowledgment>(new WifiNoAck);
-    psdu->SetDuration(GetPsduDurationId(txDuration, params));
+    /**
+     * In a BlockAck frame transmitted in response to a frame carried in HE TB PPDU under
+     * single protection settings, the Duration/ID field is set to the value obtained from
+     * the Duration/ID field of the frame that elicited the response minus the time, in
+     * microseconds between the end of the PPDU carrying the frame that elicited the response
+     * and the end of the PPDU carrying the BlockAck frame.
+     * Under multiple protection settings, the Duration/ID field in a BlockAck frame transmitted
+     * in response to a frame carried in HE TB PPDU is set according to the multiple protection
+     * settings defined in 9.2.5.2. (Sec. 9.2.5.7 of 802.11ax-2021)
+     */
+    NS_ASSERT(m_edca);
+    if (m_edca->GetTxopLimit(m_linkId).IsZero())
+    {
+        // single protection settings
+        psdu->SetDuration(Max(durationId - m_phy->GetSifs() - txDuration, Seconds(0)));
+    }
+    else
+    {
+        // multiple protection settings
+        psdu->SetDuration(Max(m_edca->GetRemainingTxop(m_linkId) - txDuration, Seconds(0)));
+    }
 
     psdu->GetPayload(0)->AddPacketTag(m_muSnrTag);
 
@@ -1354,9 +1687,8 @@
 
     NS_LOG_DEBUG("Received a Trigger Frame (basic variant) soliciting a transmission");
 
-    if (trigger.GetCsRequired() && hdr.GetAddr2() != m_txopHolder && m_navEnd > Simulator::Now())
+    if (!UlMuCsMediumIdle(trigger))
     {
-        NS_LOG_DEBUG("Carrier Sensing required and channel busy, do nothing");
         return;
     }
 
@@ -1394,7 +1726,7 @@
     {
         Ptr<QosTxop> edca = m_mac->GetQosTxop(tid);
 
-        if (!edca->GetBaAgreementEstablished(hdr.GetAddr2(), tid))
+        if (!m_mac->GetBaAgreementEstablishedAsOriginator(hdr.GetAddr2(), tid))
         {
             // no Block Ack agreement established for this TID
             continue;
@@ -1404,21 +1736,21 @@
         txParams.m_txVector = tbTxVector;
 
         // first, check if there is a pending BlockAckReq frame
-        if (Ptr<const WifiMpdu> mpdu;
-            (mpdu = edca->GetBaManager()->GetBar(false, tid, hdr.GetAddr2())) &&
-            TryAddMpdu(mpdu, txParams, ppduDuration))
+        if (auto mpdu = GetBar(edca->GetAccessCategory(), tid, hdr.GetAddr2());
+            mpdu && TryAddMpdu(mpdu, txParams, ppduDuration))
         {
             NS_LOG_DEBUG("Sending a BAR within a TB PPDU");
-            psdu = Create<WifiPsdu>(edca->GetBaManager()->GetBar(true, tid, hdr.GetAddr2()), true);
+            psdu = Create<WifiPsdu>(mpdu, true);
             break;
         }
 
         // otherwise, check if a suitable data frame is available
-        if (Ptr<WifiMpdu> mpdu; (mpdu = edca->PeekNextMpdu(m_linkId, tid, hdr.GetAddr2())))
+        auto receiver =
+            GetWifiRemoteStationManager()->GetMldAddress(hdr.GetAddr2()).value_or(hdr.GetAddr2());
+        if (auto mpdu = edca->PeekNextMpdu(m_linkId, tid, receiver))
         {
-            Ptr<WifiMpdu> item = edca->GetNextMpdu(m_linkId, mpdu, txParams, ppduDuration, false);
-
-            if (item)
+            mpdu = CreateAliasIfNeeded(mpdu);
+            if (auto item = edca->GetNextMpdu(m_linkId, mpdu, txParams, ppduDuration, false))
             {
                 // try A-MPDU aggregation
                 std::vector<Ptr<WifiMpdu>> mpduList =
@@ -1452,11 +1784,8 @@
 
     NS_LOG_DEBUG("Requested to send QoS Null frames");
 
-    if (trigger.GetCsRequired() && hdr.GetAddr2() != m_txopHolder && m_navEnd > Simulator::Now())
+    if (!UlMuCsMediumIdle(trigger))
     {
-        NS_LOG_DEBUG("Carrier Sensing required and channel busy (TA="
-                     << hdr.GetAddr2() << ", TxopHolder=" << m_txopHolder
-                     << ", NAV end=" << m_navEnd.As(Time::S) << "), do nothing");
         return;
     }
 
@@ -1495,7 +1824,7 @@
                txParams,
                ppduDuration))
     {
-        if (!m_mac->GetQosTxop(tid)->GetBaAgreementEstablished(hdr.GetAddr2(), tid))
+        if (!m_mac->GetBaAgreementEstablishedAsOriginator(hdr.GetAddr2(), tid))
         {
             NS_LOG_DEBUG("Skipping tid=" << +tid << " because no agreement established");
             header.SetQosTid(++tid);
@@ -1528,13 +1857,207 @@
 }
 
 void
+HeFrameExchangeManager::ReceiveMuBarTrigger(const CtrlTriggerHeader& trigger,
+                                            uint8_t tid,
+                                            Time durationId,
+                                            double snr)
+{
+    NS_LOG_FUNCTION(this << trigger << tid << durationId.As(Time::US) << snr);
+
+    auto agreement = m_mac->GetBaAgreementEstablishedAsRecipient(m_bssid, tid);
+
+    if (!agreement)
+    {
+        NS_LOG_DEBUG("There's not a valid agreement for this BlockAckReq");
+        return;
+    }
+
+    if (!UlMuCsMediumIdle(trigger))
+    {
+        return;
+    }
+
+    NS_LOG_DEBUG("Send Block Ack in TB PPDU");
+    auto txVector = GetHeTbTxVector(trigger, m_bssid);
+    SendBlockAck(*agreement, durationId, txVector, snr);
+}
+
+bool
+HeFrameExchangeManager::IsIntraBssPpdu(Ptr<const WifiPsdu> psdu, const WifiTxVector& txVector) const
+{
+    NS_LOG_FUNCTION(this << psdu << txVector);
+
+    // "If, based on the MAC address information of a frame carried in a received PPDU, the
+    // received PPDU satisfies both intra-BSS and inter-BSS conditions, then the received PPDU is
+    // classified as an intra-BSS PPDU." (Sec. 26.2.2 of 802.11ax-2021)
+    // Hence, check first if the intra-BSS conditions using MAC address information are satisfied:
+    // 1. "The PPDU carries a frame that has an RA, TA, or BSSID field value that is equal to
+    //    the BSSID of the BSS in which the STA is associated"
+    const auto ra = psdu->GetAddr1();
+    const auto ta = psdu->GetAddr2();
+    const auto bssid = psdu->GetHeader(0).GetAddr3();
+    const auto empty = Mac48Address();
+
+    if (ra == m_bssid || ta == m_bssid || bssid == m_bssid)
+    {
+        return true;
+    }
+
+    // 2. "The PPDU carries a Control frame that does not have a TA field and that has an
+    //    RA field value that matches the saved TXOP holder address of the BSS in which
+    //    the STA is associated"
+    if (psdu->GetHeader(0).IsCtl() && ta == empty && ra == m_txopHolder)
+    {
+        return true;
+    }
+
+    // If we get here, the intra-BSS conditions using MAC address information are not satisfied.
+    // "If the received PPDU satisfies the intra-BSS conditions using the RXVECTOR parameter
+    // BSS_COLOR and also satisfies the inter-BSS conditions using MAC address information of a
+    // frame carried in the PPDU, then the classification made using the MAC address information
+    // takes precedence."
+    // Hence, if the inter-BSS conditions using MAC address information are satisfied, the frame
+    // is classified as inter-BSS
+    // 1. "The PPDU carries a frame that has a BSSID field, the value of which is not the BSSID
+    //    of the BSS in which the STA is associated"
+    if (bssid != empty && bssid != m_bssid)
+    {
+        return false;
+    }
+
+    // 2. The PPDU carries a frame that does not have a BSSID field but has both an RA field and
+    //    TA field, neither value of which is equal to the BSSID of the BSS in which the STA is
+    //    associated
+    if (bssid == empty && ta != empty && ra != empty && ta != m_bssid && ra != m_bssid)
+    {
+        return false;
+    }
+
+    // If we get here, both intra-BSS and inter-bss conditions using MAC address information
+    // are not satisfied. Hence, the frame is classified as intra-BSS if the intra-BSS conditions
+    // using the RXVECTOR parameters are satisfied:
+    // 1. The RXVECTOR parameter BSS_COLOR of the PPDU carrying the frame is the BSS color of the
+    //    BSS of which the STA is a member
+    // This condition is used if the BSS is not disabled ("If a STA determines that the BSS color
+    // is disabled (see 26.17.3.3), then the RXVECTOR parameter BSS_COLOR of a PPDU shall not be
+    // used to classify the PPDU")
+    const auto bssColor = m_mac->GetHeConfiguration()->GetBssColor();
+    if (bssColor != 0 && bssColor == txVector.GetBssColor())
+    {
+        return true;
+    }
+
+    // the other two conditions using the RXVECTOR parameter PARTIAL_AID are not implemented
+    return false;
+}
+
+void
+HeFrameExchangeManager::UpdateNav(Ptr<const WifiPsdu> psdu, const WifiTxVector& txVector)
+{
+    NS_LOG_FUNCTION(this << psdu << txVector);
+
+    if (!psdu->HasNav())
+    {
+        return;
+    }
+
+    if (psdu->GetAddr1() == m_self)
+    {
+        // When the received frame’s RA is equal to the STA’s own MAC address, the STA
+        // shall not update its NAV (IEEE 802.11-2020, sec. 10.3.2.4)
+        return;
+    }
+
+    // The intra-BSS NAV is updated by an intra-BSS PPDU. The basic NAV is updated by an
+    // inter-BSS PPDU or a PPDU that cannot be classified as intra-BSS or inter-BSS.
+    // (Section 26.2.4 of 802.11ax-2021)
+    if (!IsIntraBssPpdu(psdu, txVector))
+    {
+        NS_LOG_DEBUG("PPDU not classified as intra-BSS, update the basic NAV");
+        VhtFrameExchangeManager::UpdateNav(psdu, txVector);
+        return;
+    }
+
+    NS_LOG_DEBUG("PPDU classified as intra-BSS, update the intra-BSS NAV");
+    Time duration = psdu->GetDuration();
+    NS_LOG_DEBUG("Duration/ID=" << duration);
+
+    // For all other received frames the STA shall update its NAV when the received
+    // Duration is greater than the STA’s current NAV value (IEEE 802.11-2020 sec. 10.3.2.4)
+    auto intraBssNavEnd = Simulator::Now() + duration;
+    if (intraBssNavEnd > m_intraBssNavEnd)
+    {
+        m_intraBssNavEnd = intraBssNavEnd;
+        NS_LOG_DEBUG("Updated intra-BSS NAV=" << m_intraBssNavEnd);
+
+        // A STA that used information from an RTS frame as the most recent basis to update
+        // its NAV setting is permitted to reset its NAV if no PHY-RXSTART.indication
+        // primitive is received from the PHY during a NAVTimeout period starting when the
+        // MAC receives a PHY-RXEND.indication primitive corresponding to the detection of
+        // the RTS frame. NAVTimeout period is equal to:
+        // (2 x aSIFSTime) + (CTS_Time) + aRxPHYStartDelay + (2 x aSlotTime)
+        // The “CTS_Time” shall be calculated using the length of the CTS frame and the data
+        // rate at which the RTS frame used for the most recent NAV update was received
+        // (IEEE 802.11-2016 sec. 10.3.2.4)
+        if (psdu->GetHeader(0).IsRts())
+        {
+            WifiTxVector ctsTxVector =
+                GetWifiRemoteStationManager()->GetCtsTxVector(psdu->GetAddr2(), txVector.GetMode());
+            auto navResetDelay =
+                2 * m_phy->GetSifs() +
+                WifiPhy::CalculateTxDuration(GetCtsSize(), ctsTxVector, m_phy->GetPhyBand()) +
+                m_phy->CalculatePhyPreambleAndHeaderDuration(ctsTxVector) + 2 * m_phy->GetSlot();
+            m_intraBssNavResetEvent =
+                Simulator::Schedule(navResetDelay,
+                                    &HeFrameExchangeManager::IntraBssNavResetTimeout,
+                                    this);
+        }
+    }
+    NS_LOG_DEBUG("Current intra-BSS NAV=" << m_intraBssNavEnd);
+
+    m_channelAccessManager->NotifyNavStartNow(duration);
+}
+
+void
+HeFrameExchangeManager::ClearTxopHolderIfNeeded()
+{
+    NS_LOG_FUNCTION(this);
+    if (m_intraBssNavEnd <= Simulator::Now())
+    {
+        m_txopHolder.reset();
+    }
+}
+
+void
+HeFrameExchangeManager::NavResetTimeout()
+{
+    NS_LOG_FUNCTION(this);
+    m_navEnd = Simulator::Now();
+    // Do not reset the TXOP holder because the basic NAV is updated by inter-BSS frames
+    // The NAV seen by the ChannelAccessManager is now the intra-BSS NAV only
+    Time intraBssNav = Simulator::GetDelayLeft(m_intraBssNavResetEvent);
+    m_channelAccessManager->NotifyNavResetNow(intraBssNav);
+}
+
+void
+HeFrameExchangeManager::IntraBssNavResetTimeout()
+{
+    NS_LOG_FUNCTION(this);
+    m_intraBssNavEnd = Simulator::Now();
+    ClearTxopHolderIfNeeded();
+    // The NAV seen by the ChannelAccessManager is now the basic NAV only
+    Time basicNav = Simulator::GetDelayLeft(m_navResetEvent);
+    m_channelAccessManager->NotifyNavResetNow(basicNav);
+}
+
+void
 HeFrameExchangeManager::SetTxopHolder(Ptr<const WifiPsdu> psdu, const WifiTxVector& txVector)
 {
     NS_LOG_FUNCTION(this << psdu << txVector);
 
-    if (psdu->GetHeader(0).IsTrigger())
+    if (psdu->GetHeader(0).IsTrigger() && psdu->GetAddr2() == m_bssid)
     {
-        m_txopHolder = psdu->GetAddr2();
+        m_txopHolder = m_bssid;
     }
     else if (!txVector.IsUlMu()) // the sender of a TB PPDU is not the TXOP holder
     {
@@ -1542,6 +2065,58 @@
     }
 }
 
+bool
+HeFrameExchangeManager::VirtualCsMediumIdle() const
+{
+    // For an HE STA maintaining two NAVs, if both the NAV timers are 0, the virtual CS indication
+    // is that the medium is idle; if at least one of the two NAV timers is nonzero, the virtual CS
+    // indication is that the medium is busy. (Sec. 26.2.4 of 802.11ax-2021)
+    return m_navEnd <= Simulator::Now() && m_intraBssNavEnd <= Simulator::Now();
+}
+
+bool
+HeFrameExchangeManager::UlMuCsMediumIdle(const CtrlTriggerHeader& trigger) const
+{
+    if (!trigger.GetCsRequired())
+    {
+        NS_LOG_DEBUG("CS not required");
+        return true;
+    }
+
+    // A non-AP STA does not consider the intra-BSS NAV in determining whether to respond to a
+    // Trigger frame sent by the AP with which the non-AP STA is associated.
+    // A non-AP STA considers the basic NAV in determining whether to respond to a Trigger frame
+    // sent by the AP with which the non-AP STA is associated. (Sec. 26.5.2.5 of 802.11ax-2021)
+    const Time now = Simulator::Now();
+    if (m_navEnd > now)
+    {
+        NS_LOG_DEBUG("Basic NAV indicates medium busy");
+        return false;
+    }
+
+    NS_ASSERT_MSG(m_staMac, "UL MU CS is only performed by non-AP STAs");
+    const auto userInfoIt = trigger.FindUserInfoWithAid(m_staMac->GetAssociationId());
+    NS_ASSERT_MSG(userInfoIt != trigger.end(),
+                  "No User Info field for STA (" << m_self
+                                                 << ") AID=" << m_staMac->GetAssociationId());
+
+    std::set<uint8_t> indices;
+
+    if (trigger.IsMuRts())
+    {
+        auto ctsTxVector = GetCtsTxVectorAfterMuRts(trigger, m_staMac->GetAssociationId());
+        auto bw = ctsTxVector.GetChannelWidth();
+        indices = m_phy->GetOperatingChannel().GetAll20MHzChannelIndicesInPrimary(bw);
+    }
+    else
+    {
+        indices =
+            m_phy->GetOperatingChannel().Get20MHzIndicesCoveringRu(userInfoIt->GetRuAllocation(),
+                                                                   trigger.GetUlBandwidth());
+    }
+    return !m_channelAccessManager->GetPer20MHzBusy(indices);
+}
+
 void
 HeFrameExchangeManager::ReceiveMpdu(Ptr<const WifiMpdu> mpdu,
                                     RxSignalInfo rxSignalInfo,
@@ -1577,14 +2152,15 @@
             mpdu->GetPacket()->PeekHeader(blockAckReq);
             NS_ABORT_MSG_IF(blockAckReq.IsMultiTid(), "Multi-TID BlockAckReq not supported");
             uint8_t tid = blockAckReq.GetTidInfo();
-            auto agreementIt = m_agreements.find({sender, tid});
-            NS_ASSERT(agreementIt != m_agreements.end());
-            agreementIt->second.NotifyReceivedBar(blockAckReq.GetStartingSequence());
+            GetBaManager(tid)->NotifyGotBlockAckRequest(
+                m_mac->GetMldAddress(sender).value_or(sender),
+                tid,
+                blockAckReq.GetStartingSequence());
 
             // Block Acknowledgment context
             acknowledgment->stationsReceivingMultiStaBa.emplace(std::make_pair(sender, tid), index);
             acknowledgment->baType.m_bitmapLen.push_back(
-                GetBlockAckType(sender, tid).m_bitmapLen.at(0));
+                m_mac->GetBaTypeAsRecipient(sender, tid).m_bitmapLen.at(0));
             uint16_t staId = txVector.GetHeMuUserInfoMap().begin()->first;
             m_muSnrTag.Set(staId, rxSignalInfo.snr);
         }
@@ -1593,9 +2169,7 @@
             NS_LOG_DEBUG("Received an S-MPDU in a TB PPDU from " << sender << " (" << *mpdu << ")");
 
             uint8_t tid = hdr.GetQosTid();
-            auto agreementIt = m_agreements.find({sender, tid});
-            NS_ASSERT(agreementIt != m_agreements.end());
-            agreementIt->second.NotifyReceivedMpdu(mpdu);
+            GetBaManager(tid)->NotifyGotMpdu(mpdu);
 
             // Acknowledgment context of Multi-STA Block Acks
             acknowledgment->stationsReceivingMultiStaBa.emplace(std::make_pair(sender, tid), index);
@@ -1620,7 +2194,8 @@
             m_multiStaBaEvent = Simulator::Schedule(m_phy->GetSifs(),
                                                     &HeFrameExchangeManager::SendMultiStaBlockAck,
                                                     this,
-                                                    std::cref(m_txParams));
+                                                    std::cref(m_txParams),
+                                                    mpdu->GetHeader().GetDuration());
         }
 
         // remove the sender from the set of stations that are expected to send a TB PPDU
@@ -1650,7 +2225,7 @@
         m_txTimer.GetReason() == WifiTxTimer::WAIT_QOS_NULL_AFTER_BSRP_TF &&
         !inAmpdu) // if in A-MPDU, processing is done at the end of A-MPDU reception
     {
-        Mac48Address sender = hdr.GetAddr2();
+        const auto& sender = hdr.GetAddr2();
 
         if (m_staExpectTbPpduFrom.find(sender) == m_staExpectTbPpduFrom.end())
         {
@@ -1707,6 +2282,18 @@
             m_channelAccessManager->NotifyCtsTimeoutResetNow();
             Simulator::Schedule(m_phy->GetSifs(), &HeFrameExchangeManager::SendPsduMap, this);
         }
+        else if (hdr.IsCts() && !m_psduMap.empty() && m_txTimer.IsRunning() &&
+                 m_txTimer.GetReason() == WifiTxTimer::WAIT_CTS_AFTER_MU_RTS)
+        {
+            NS_ABORT_MSG_IF(inAmpdu, "Received CTS as part of an A-MPDU");
+            NS_ASSERT(hdr.GetAddr1() == m_self);
+
+            NS_LOG_DEBUG("Received a CTS frame in response to an MU-RTS");
+
+            m_txTimer.Cancel();
+            m_channelAccessManager->NotifyCtsTimeoutResetNow();
+            Simulator::Schedule(m_phy->GetSifs(), &HeFrameExchangeManager::SendPsduMap, this);
+        }
         else if (hdr.IsAck() && m_txTimer.IsRunning() &&
                  m_txTimer.GetReason() == WifiTxTimer::WAIT_NORMAL_ACK_AFTER_DL_MU_PPDU)
         {
@@ -1755,8 +2342,11 @@
             mpdu->GetPacket()->PeekHeader(blockAck);
             uint8_t tid = blockAck.GetTidInfo();
             std::pair<uint16_t, uint16_t> ret =
-                GetBaManager(tid)->NotifyGotBlockAck(blockAck, hdr.GetAddr2(), {tid});
-            GetWifiRemoteStationManager()->ReportAmpduTxStatus(hdr.GetAddr2(),
+                GetBaManager(tid)->NotifyGotBlockAck(m_linkId,
+                                                     blockAck,
+                                                     m_mac->GetMldAddress(sender).value_or(sender),
+                                                     {tid});
+            GetWifiRemoteStationManager()->ReportAmpduTxStatus(sender,
                                                                ret.first,
                                                                ret.second,
                                                                rxSignalInfo.snr,
@@ -1775,7 +2365,12 @@
                 // we do not expect any other BlockAck frame
                 m_txTimer.Cancel();
                 m_channelAccessManager->NotifyAckTimeoutResetNow();
-                m_triggerFrame = nullptr; // this is strictly needed for DL_MU_TF_MU_BAR only
+                if (m_triggerFrame)
+                {
+                    // this is strictly needed for DL_MU_TF_MU_BAR only
+                    DequeueMpdu(m_triggerFrame);
+                    m_triggerFrame = nullptr;
+                }
 
                 m_edca->ResetCw(m_linkId);
                 m_psduMap.clear();
@@ -1820,7 +2415,7 @@
                 {
                     // Acknowledgment context
                     NS_ABORT_IF(m_psduMap.empty() || m_psduMap.begin()->first != staId);
-                    GetBaManager(tid)->NotifyGotAck(*m_psduMap.at(staId)->begin());
+                    GetBaManager(tid)->NotifyGotAck(m_linkId, *m_psduMap.at(staId)->begin());
                 }
                 else
                 {
@@ -1835,11 +2430,12 @@
                         tid = *tids.begin();
                     }
 
-                    std::pair<uint16_t, uint16_t> ret =
-                        GetBaManager(tid)->NotifyGotBlockAck(blockAck,
-                                                             hdr.GetAddr2(),
-                                                             {tid},
-                                                             index);
+                    std::pair<uint16_t, uint16_t> ret = GetBaManager(tid)->NotifyGotBlockAck(
+                        m_linkId,
+                        blockAck,
+                        m_mac->GetMldAddress(hdr.GetAddr2()).value_or(hdr.GetAddr2()),
+                        {tid},
+                        index);
                     GetWifiRemoteStationManager()->ReportAmpduTxStatus(hdr.GetAddr2(),
                                                                        ret.first,
                                                                        ret.second,
@@ -1867,6 +2463,14 @@
             // cancel the timer
             m_txTimer.Cancel();
             m_channelAccessManager->NotifyAckTimeoutResetNow();
+            // dequeue BlockAckReq frames included in acknowledged TB PPDUs (if any)
+            for (const auto& [staId, psdu] : m_psduMap)
+            {
+                if (psdu->GetNMpdus() == 1 && psdu->GetHeader(0).IsBlockAckReq())
+                {
+                    DequeuePsdu(psdu);
+                }
+            }
             m_psduMap.clear();
         }
         else if (hdr.IsBlockAck() && m_txTimer.IsRunning() &&
@@ -1907,7 +2511,35 @@
 
             uint16_t staId = m_staMac->GetAssociationId();
 
-            if (trigger.IsMuBar())
+            if (trigger.IsMuRts())
+            {
+                Mac48Address sender = hdr.GetAddr2();
+                NS_LOG_DEBUG("Received MU-RTS Trigger Frame from=" << sender);
+                GetWifiRemoteStationManager()->ReportRxOk(sender, rxSignalInfo, txVector);
+
+                // If a non-AP STA receives an MU-RTS Trigger frame, the non-AP STA shall commence
+                // the transmission of a CTS frame response at the SIFS time boundary after
+                // the end of a received PPDU when all the following conditions are met:
+                // - The MU-RTS Trigger frame has one of the User Info fields addressed to
+                //   the non-AP STA (this is guaranteed if we get here)
+                // - The UL MU CS condition indicates that the medium is idle
+                // (Sec. 26.2.6.3 of 802.11ax-2021)
+                if (UlMuCsMediumIdle(trigger))
+                {
+                    NS_LOG_DEBUG("Schedule CTS");
+                    Simulator::Schedule(m_phy->GetSifs(),
+                                        &HeFrameExchangeManager::SendCtsAfterMuRts,
+                                        this,
+                                        hdr,
+                                        trigger,
+                                        rxSignalInfo.snr);
+                }
+                else
+                {
+                    NS_LOG_DEBUG("Cannot schedule CTS");
+                }
+            }
+            else if (trigger.IsMuBar())
             {
                 Mac48Address sender = hdr.GetAddr2();
                 NS_LOG_DEBUG("Received MU-BAR Trigger Frame from=" << sender);
@@ -1919,23 +2551,17 @@
                 NS_ABORT_MSG_IF(blockAckReq.IsMultiTid(), "Multi-TID BlockAckReq not supported");
                 uint8_t tid = blockAckReq.GetTidInfo();
 
-                auto agreementIt = m_agreements.find({sender, tid});
+                GetBaManager(tid)->NotifyGotBlockAckRequest(
+                    m_mac->GetMldAddress(sender).value_or(sender),
+                    tid,
+                    blockAckReq.GetStartingSequence());
 
-                if (agreementIt == m_agreements.end())
-                {
-                    NS_LOG_DEBUG("There's not a valid agreement for this BlockAckReq");
-                    return;
-                }
-
-                agreementIt->second.NotifyReceivedBar(blockAckReq.GetStartingSequence());
-
-                NS_LOG_DEBUG("Schedule Block Ack in TB PPDU");
                 Simulator::Schedule(m_phy->GetSifs(),
-                                    &HeFrameExchangeManager::SendBlockAck,
+                                    &HeFrameExchangeManager::ReceiveMuBarTrigger,
                                     this,
-                                    agreementIt->second,
+                                    trigger,
+                                    tid,
                                     hdr.GetDuration(),
-                                    GetHeTbTxVector(trigger, hdr.GetAddr2()),
                                     rxSignalInfo.snr);
             }
             else if (trigger.IsBasic())
@@ -2016,7 +2642,7 @@
                     acknowledgment->stationsReceivingMultiStaBa.emplace(std::make_pair(sender, tid),
                                                                         index + i++);
                     acknowledgment->baType.m_bitmapLen.push_back(
-                        GetBlockAckType(sender, tid).m_bitmapLen.at(0));
+                        m_mac->GetBaTypeAsRecipient(sender, tid).m_bitmapLen.at(0));
                 }
             }
             uint16_t staId = txVector.GetHeMuUserInfoMap().begin()->first;
@@ -2029,7 +2655,8 @@
             m_multiStaBaEvent = Simulator::Schedule(m_phy->GetSifs(),
                                                     &HeFrameExchangeManager::SendMultiStaBlockAck,
                                                     this,
-                                                    std::cref(m_txParams));
+                                                    std::cref(m_txParams),
+                                                    psdu->GetDuration());
         }
 
         // remove the sender from the set of stations that are expected to send a TB PPDU
